#include "StdAfx.h"
#include "CGDrawable.h"

CGDrawable::CGDrawable()
{

	pDIB = NULL;
	mHDIBSec = NULL;
	mDIBSecDC = NULL;
}

CGDrawable::~CGDrawable(void)
{
	if (mCgContext)
		CGContextRelease(mCgContext);

	if (mDIBSecDC)
		DeleteDC(mDIBSecDC);

	if (mHDIBSec)
		DeleteObject(mHDIBSec);
}

bool CGDrawable::createImage(unsigned int w, unsigned int h)
{
	mBpp = 4;
	unsigned int bytesPerRow = w * mBpp;

	// DIB
	BITMAPINFO bi;
	ZeroMemory(&bi, sizeof(bi));

	bi.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	bi.bmiHeader.biBitCount = 32;
	bi.bmiHeader.biPlanes = 1;
	bi.bmiHeader.biWidth = w;
	bi.bmiHeader.biHeight = h;
	bi.bmiHeader.biCompression = BI_RGB;

	mHDIBSec = CreateDIBSection(NULL, &bi, DIB_RGB_COLORS, (void **)&pDIB, NULL, 0);

	HDC hdcDesktop = GetDC(NULL);
	mDIBSecDC = CreateCompatibleDC(hdcDesktop);
	ReleaseDC(NULL, hdcDesktop);

	SelectObject(mDIBSecDC, mHDIBSec);
	/////

	const size_t bitsPerComponent = 8;
	CGColorSpaceRef colorSpace = CGColorSpaceCreateDeviceRGB();
    mCgContext = 
		CGBitmapContextCreate(
									pDIB,w ,h,
									bitsPerComponent,
									bytesPerRow,
									colorSpace,
									(CGImageAlphaInfo)(kCGBitmapByteOrder32Little|kCGImageAlphaNoneSkipFirst));
	CGColorSpaceRelease(colorSpace);
	if (!mCgContext)
		return false;

    CGContextTranslateCTM(mCgContext, 0, h);
    CGContextScaleCTM(mCgContext, 1, -1);

	mWidth = w;
	mHeight = h;

	return true;
}

void CGDrawable::copyToGDI(HDC hdc, int dx, int dy)
{/*
	if (update)
	{
		unsigned int x, y;
		unsigned char* p = (unsigned char*)mImageBuf;
		unsigned char* q = pDIB;
		int step = mBpp;

		for (y = 0;y < mHeight;y++)
		{
			for (x = 0;x < mWidth;x++)
			{
				q[0] = p[2];
				q[1] = p[1];
				q[2] = p[0];

				p += step;
				q += 3;
			}
		}
	}
*/
	if (hdc)
		BitBlt(hdc, dx, dy, mWidth, mHeight, mDIBSecDC, 0, 0, SRCCOPY);
}