#include "stdafx.h"
#include <tchar.h>
#include <string.h>
#include "CGFontWrapper.h"


CGFontWrapper::CGFontWrapper(int height, int weight, LPCTSTR face, DWORD pitchAndFamily)
{
	mCGFont = NULL;
	mHGDIFont = CreateFont(height, 0, 0, 0, weight, 
		FALSE, FALSE, FALSE, DEFAULT_CHARSET, OUT_DEFAULT_PRECIS,
        CLIP_DEFAULT_PRECIS, PROOF_QUALITY, pitchAndFamily, face);

/*
    HDC hdc = GetDC(0);
    SaveDC(hdc);
    
    SelectObject(hdc, mHGDIFont);
    UINT bufferSize = GetOutlineTextMetricsW(hdc, 0, NULL);

    if (bufferSize != 0)
    {
        OUTLINETEXTMETRICW* metrics = (OUTLINETEXTMETRICW*)malloc(bufferSize);
        GetOutlineTextMetricsW(hdc, bufferSize, metrics);
        WCHAR* faceName = (WCHAR*)((uintptr_t)metrics + (uintptr_t)metrics->otmpFaceName);

        CFStringRef cfName = CFStringCreateWithCharacters(NULL, (const UniChar*)faceName, wcslen(faceName));
        mCGFont = CGFontCreateWithFontName(cfName);
        CFRelease(cfName);


		free(metrics);
	}

    RestoreDC(hdc, -1);
    ReleaseDC(0, hdc);*/

	CFStringRef cfName = CFStringCreateWithCharacters(NULL, (const UniChar*)face, _tcslen(face));
    mCGFont = CGFontCreateWithFontName(cfName);
    CFRelease(cfName);

}

bool CGFontWrapper::getGlyphIndices(HFONT hfont, CGGlyph* buf, int len, const TCHAR* str)
{
    HDC hdc = GetDC(0);
    SaveDC(hdc);
    SelectObject(hdc, hfont);

    GetGlyphIndices(hdc, str, len, buf, GGI_MARK_NONEXISTING_GLYPHS);
    
    RestoreDC(hdc, -1);
    ReleaseDC(0, hdc);

    for (unsigned i = 0; i < len; i++) {
        if (buf[i] == 0xFFFFFFFF) {
            return false;
        }
    }

	return true;
}

CGFontWrapper::~CGFontWrapper(void)
{
	if (mCGFont)
		CGFontRelease(mCGFont);

	if (mHGDIFont)
		DeleteObject(mHGDIFont);
}
